/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package com.supinfo.spitfireboard.jpa;

import com.supinfo.spitfireboard.dao.TopicDao;
import com.supinfo.spitfireboard.entities.Topic;
import java.util.List;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;
import javax.persistence.criteria.Root;

/**
 *
 * @author Fabien LOISON
 */
@Stateless
public class JpaTopicDao implements TopicDao {
    @PersistenceContext
    private EntityManager em;
    
    @Override
    public Topic getById(Long id) {
        CriteriaBuilder builder = em.getCriteriaBuilder();
        CriteriaQuery<Topic> query = builder.createQuery(Topic.class);
        Root<Topic> board = query.from(Topic.class);
        query.where(builder.equal(board.get("id"), id));
        return em.createQuery(query).getSingleResult();
    }
    
    @Override
    public List<Topic> getTopicsByBoardId(Long boardId) {
        CriteriaBuilder builder = em.getCriteriaBuilder();
        CriteriaQuery<Topic> query = builder.createQuery(Topic.class);
        Root<Topic> topic = query.from(Topic.class);
        query.where(builder.equal(topic.get("boardId"), boardId));
        query.orderBy(builder.desc(topic.get("creationDate")));
        return em.createQuery(query).getResultList();
    }
    
    @Override
    public Long persistTopic(Topic topic) {
        em.persist(topic);
        em.flush();
        return topic.getId();
    }
    
    @Override
    public void delete(Long id) {
        Topic topic = this.getById(id);
        em.remove(topic);
    }
}
