/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package com.supinfo.spitfireboard.servlets;

import com.supinfo.spitfireboard.entities.Board;
import com.supinfo.spitfireboard.entities.Topic;
import com.supinfo.spitfireboard.entities.User;
import com.supinfo.spitfireboard.services.ForumService;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.ejb.EJB;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.RequestScoped;
import javax.faces.context.ExternalContext;
import javax.faces.context.FacesContext;

/**
 *
 * @author Fabien LOISON
 */
@ManagedBean
@RequestScoped
public class BoardController {
    
    @EJB
    private ForumService forumService;

    /**
     * Creates a new instance of boardController
     */
    public BoardController() {
    }
    
    private Long getBoardId() {
        FacesContext facesContext = FacesContext.getCurrentInstance();
        String idStr = (String) facesContext.getExternalContext().getRequestParameterMap().get("id");
        if (idStr == null) {
            return null;
        }
        return Long.valueOf(idStr);
    }
    
    private User getLoggedUser() {
        return (User) FacesContext.getCurrentInstance().getExternalContext().getSessionMap().get("user");
    }
    
    private String getValue(String fieldName) {
        FacesContext facesContext = FacesContext.getCurrentInstance();
        return (String) facesContext.getExternalContext().getRequestParameterMap().get(fieldName);
    }
    
    public Board getBoard() {
        return forumService.getBoard(this.getBoardId());
    }
    
    public List<Topic> getTopics() {
        return forumService.getBoardTopics(this.getBoardId());
    }
    
    public List<String> doNewTopic() {
        List<String> errors = new ArrayList<String>();
        
        // Check for empty fields
        if (this.getValue("title").equals("")) {
            errors.add("The 'Topic title' field is empty");
        }
        if (this.getValue("message").equals("")) {
            errors.add("The 'Message' field is empty");
        }
        
        // No error...
        if (errors.isEmpty()) {
            Long topicId = null;
            try {
                topicId = forumService.newTopic(
                        this.getLoggedUser().getId(), 
                        (Long) Long.valueOf(this.getValue("boardId")), 
                        this.getValue("title"), 
                        this.getValue("message")
                );
            }
            catch (Exception ex) {
                errors.add("Oops! Something wrong appened.");
                return errors;
            }
            
            // Redirect
            ExternalContext context = FacesContext.getCurrentInstance().getExternalContext();
            try {
                context.redirect("topic.xhtml?id=" + String.valueOf(topicId));
            } catch (IOException ex) {
                Logger.getLogger(BoardController.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
        
        return errors;
    }
    
}
