/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package com.supinfo.spitfireboard.servlets;

import com.supinfo.spitfireboard.entities.Post;
import com.supinfo.spitfireboard.entities.Topic;
import com.supinfo.spitfireboard.services.ForumService;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.ejb.EJB;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.RequestScoped;
import javax.faces.context.ExternalContext;
import javax.faces.context.FacesContext;

/**
 *
 * @author Fabien LOISON
 */
@ManagedBean
@RequestScoped
public class TopicController {
    
    @EJB
    private ForumService forumService;

    /**
     * Creates a new instance of TopicController
     */
    public TopicController() {
    }
    
    private String getValue(String fieldName) {
        FacesContext facesContext = FacesContext.getCurrentInstance();
        return (String) facesContext.getExternalContext().getRequestParameterMap().get(fieldName);
    }
    
    private Long getTopicId() {
        FacesContext facesContext = FacesContext.getCurrentInstance();
        String idStr = (String) facesContext.getExternalContext().getRequestParameterMap().get("id");
        if (idStr == null) {
            return null;
        }
        return Long.valueOf(idStr);
    }
    
    public Topic getTopic() {
        return forumService.getTopic(this.getTopicId());
    }
    
    public List<Post> getPosts() {
        return forumService.getTopicPosts(this.getTopicId());
    }
    
    public List<String> doLock() {
        List<String> errors = new ArrayList<String>();
        
        try {
            forumService.lockTopic(this.getTopicId());
        }
        catch (Exception ex) {
            errors.add("Oops! Something wrong appened.");
            return errors;
        }
        
        ExternalContext context = FacesContext.getCurrentInstance().getExternalContext();
        try {
            context.redirect("topic.xhtml?id=" + this.getTopicId());
        } catch (IOException ex) {
            Logger.getLogger(TopicController.class.getName()).log(Level.SEVERE, null, ex);
        }
        
        return errors;
    }
    
    public List<String> doUnlock() {
        List<String> errors = new ArrayList<String>();
        
        try {
            forumService.unlockTopic(this.getTopicId());
        }
        catch (Exception ex) {
            errors.add("Oops! Something wrong appened.");
            return errors;
        }
        
        ExternalContext context = FacesContext.getCurrentInstance().getExternalContext();
        try {
            context.redirect("topic.xhtml?id=" + this.getTopicId());
        } catch (IOException ex) {
            Logger.getLogger(TopicController.class.getName()).log(Level.SEVERE, null, ex);
        }
        
        return errors;
    }
    
    public List<String> doDelete() {
        List<String> errors = new ArrayList<String>();
        
        try {
            forumService.deleteTopic(this.getTopicId());
        }
        catch (Exception ex) {
            errors.add("Oops! Something wrong appened.");
            return errors;
        }
        
        // Redirect
        ExternalContext context = FacesContext.getCurrentInstance().getExternalContext();
        try {
            context.redirect("index.xhtml");
        } catch (IOException ex) {
            Logger.getLogger(TopicController.class.getName()).log(Level.SEVERE, null, ex);
        }
        
        return null;
    }
    
    public List<String> doEdit() {
        List<String> errors = new ArrayList<String>();
        
        try {
            forumService.topicEdit(Long.valueOf(this.getValue("topicId")), this.getValue("title"));
        }
        catch (Exception ex) {
            errors.add("Oops! Something wrong appened.");
            return errors;
        }
        
        // Redirect
        ExternalContext context = FacesContext.getCurrentInstance().getExternalContext();
        try {
            context.redirect("topic.xhtml?id=" + Long.valueOf(this.getValue("topicId")));
        } catch (IOException ex) {
            Logger.getLogger(TopicController.class.getName()).log(Level.SEVERE, null, ex);
        }
        
        return null;
    }
    
}
